<?php
/*
  ****************************************************************************
  ***                                                                      ***
  ***      ViArt Shop Enterprise 2.7.1                                     ***
  ***      File:  admin_newsletter.php                                     ***
  ***      Built: Wed Sep 20 13:19:51 2006                                 ***
  ***      http://www.viart.com                                            ***
  ***                                                                      ***
  ****************************************************************************
*/


	include_once ("./admin_config.php");
	include_once ($root_folder_path . "includes/common.php");
	include_once ($root_folder_path . "includes/record.php");
	include_once ($root_folder_path . "includes/date_functions.php");


	check_admin_security("newsletter");

  $t = new VA_Template($settings["admin_templates_dir"]);
  $t->set_file("main","admin_newsletter.html");

	$t->set_var("admin_href", "admin.php");
	$t->set_var("admin_newsletters_href", "admin_newsletter.php");
	$t->set_var("admin_newsletter_href",  "admin_newsletter.php");
	$t->set_var("datetime_format", join("", $datetime_edit_format));

	$mail_types = 
		array( 
			array(1, "HTML"), array(0, "Plain Text")
		);


	$r = new VA_Record($table_prefix . "newsletters");
	$return_page = "admin_newsletters.php";

	$r->add_where("newsletter_id", INTEGER);

	$r->add_checkbox("is_active", INTEGER);
	$r->add_textbox("newsletter_date", DATETIME, "Date");
	$r->change_property("newsletter_date", VALUE_MASK, $datetime_edit_format);
	$r->change_property("newsletter_date", REQUIRED, true);
	$r->add_radio("mail_type", INTEGER, $mail_types, "Type");
	$r->add_textbox("mail_from", TEXT, "From");
	$r->add_textbox("mail_reply_to", TEXT, "Reply To");
	$r->add_textbox("mail_return_path", TEXT, "Return Path");

	$r->add_textbox("newsletter_subject", TEXT, "Subject");
	$r->change_property("newsletter_subject", REQUIRED, true);
	$r->add_textbox("newsletter_body", TEXT, "Subject");

	$r->add_textbox("added_by", TEXT);
	$r->change_property("added_by", USE_IN_UPDATE, false);
	$r->add_textbox("added_date", DATETIME);
	$r->change_property("added_date", USE_IN_UPDATE, false);

	$r->add_textbox("edited_by", TEXT);
	$r->add_textbox("edited_date", DATETIME);

	$r->add_textbox("emails_left", INTEGER);
	$r->change_property("emails_left", USE_IN_UPDATE, false);
	$r->add_textbox("emails_sent", INTEGER);
	$r->change_property("emails_sent", USE_IN_UPDATE, false);
	$r->add_textbox("is_sent", INTEGER);
	$r->change_property("is_sent", USE_IN_UPDATE, false);
	$r->add_textbox("is_prepared", INTEGER);

	$r->add_checkbox("subscribed_recipients", TEXT);
	$r->add_checkbox("users_recipients", TEXT);
	$r->add_checkbox("orders_recipients", TEXT);
	$r->add_checkbox("admins_recipients", TEXT);

	$r->get_form_parameters();
	$operation = get_param("operation");
	$newsletter_id = get_param("newsletter_id");

	if(strlen($operation))
	{
		if($operation == "cancel")
		{
			header("Location: " . $return_page);
			exit;
		}
		else if($operation == "delete" && $newsletter_id)
		{
			$r->delete_record();		
			$sql  = " DELETE FROM " . $table_prefix . "newsletters_emails ";
			$sql .= " WHERE newsletter_id=" . $db->tosql($newsletter_id, INTEGER);
			$db->query($sql);
			header("Location: " . $return_page);
			exit;
		}

		if ($r->get_value("subscribed_recipients") == "1") {
			$r->set_value("subscribed_recipients", "all");
		}

		$users_recipients = "";
		$user_types_total = get_param("user_types_total");
		for($i = 1; $i <= $user_types_total; $i++) {
			$user_type = get_param("user_type_" . $i);
			if (strlen($user_type)) {
				if (strlen($users_recipients)) { $users_recipients .= ","; }
				$users_recipients .= $user_type;
			}
		}
		$r->set_value("users_recipients", $users_recipients);

		$orders_recipients = "";
		$order_statuses_total = get_param("order_statuses_total");
		for($i = 1; $i <= $order_statuses_total; $i++) {
			$order_status = get_param("order_status_" . $i);
			if (strlen($order_status)) {
				if (strlen($orders_recipients)) { $orders_recipients .= ","; }
				$orders_recipients .= $order_status;
			}
		}
		$r->set_value("orders_recipients", $orders_recipients);

		$admins_recipients = "";
		$privileges_total = get_param("privileges_total");
		for($i = 1; $i <= $privileges_total; $i++) {
			$privilege_id = get_param("privilege_" . $i);
			if (strlen($privilege_id)) {
				if (strlen($admins_recipients)) { $admins_recipients .= ","; }
				$admins_recipients .= $privilege_id;
			}
		}
		$r->set_value("admins_recipients", $admins_recipients);


		$r->validate();


		if(!strlen($r->errors))
		{

			if(strlen($newsletter_id)) {
				$r->set_value("edited_by",   get_session("session_admin_id"));
				$r->set_value("edited_date", va_time());
				$r->set_value("is_prepared", 0);
				$r->update_record();

				$sql  = " DELETE FROM " . $table_prefix . "newsletters_emails ";
				$sql .= " WHERE newsletter_id=" . $db->tosql($newsletter_id, INTEGER);
				$db->query($sql);					

			} else {
				$r->set_value("added_by",   get_session("session_admin_id"));
				$r->set_value("added_date", va_time());
				$r->set_value("edited_by",   get_session("session_admin_id"));
				$r->set_value("edited_date", va_time());
				$r->set_value("emails_left", 0);
				$r->set_value("emails_sent", 0);
				$r->set_value("is_sent", 0);
				$r->set_value("is_prepared", 0);
				$r->insert_record();
			}
			
			header ("Location: " . $return_page);
			exit;
		}
	}
	else if(strlen($newsletter_id))
	{
		$r->get_db_values();
		if ($r->get_value("subscribed_recipients") == "all") {
			$r->set_value("subscribed_recipients", 1);
		}
		if ($r->get_value("is_sent") == "1") {
			$r->errors = "Newsletter has already been sent.";
		}
	}
	else // new record (set default values)
	{
		$r->set_value("is_active", 1);
		$r->set_value("newsletter_date", va_time());
		$r->set_value("mail_type", 1);

	}

	$users_recipients = explode(",", $r->get_value("users_recipients"));
	$orders_recipients = explode(",", $r->get_value("orders_recipients"));
	$admins_recipients = explode(",", $r->get_value("admins_recipients"));

	$index = 0;
	$sql = "SELECT * FROM " . $table_prefix . "user_types ";
	$db->query($sql);
	while ($db->next_record()) {
		$index++;
		$type_id = $db->f("type_id");
		$type_name = $db->f("type_name");
		$user_type_checked = in_array($type_id, $users_recipients) ? " checked " : "";
		$t->set_var("index", $index);
		$t->set_var("type_id", $type_id);
		$t->set_var("user_type_checked", $user_type_checked);
		$t->set_var("type_name", $type_name);
		$t->parse("user_types", true);
	}
	$t->set_var("user_types_total", $index);

	$index = 0;
	$sql = "SELECT * FROM " . $table_prefix . "order_statuses ";
	$db->query($sql);
	while ($db->next_record()) {
		$index++;
		$status_id = $db->f("status_id");
		$status_name = $db->f("status_name");
		$order_status_checked = in_array($status_id, $orders_recipients) ? " checked " : "";
		$t->set_var("index", $index);
		$t->set_var("status_id", $status_id);
		$t->set_var("order_status_checked", $order_status_checked);
		$t->set_var("status_name", $status_name);
		$t->parse("order_statuses_cols", true);
		if ($index % 4 == 0) {
			$t->parse("order_statuses_rows", true);
			$t->set_var("order_statuses_cols", "");
		}
	}
	if ($index % 4 != 0) {
		$t->parse("order_statuses_rows", true);
	}
	$t->set_var("order_statuses_total", $index);

	$index = 0;
	$sql  = " SELECT privilege_id,privilege_name FROM " . $table_prefix . "admin_privileges ";
	$db->query($sql);
	while ($db->next_record()) {
		$index++;
		$privilege_id = $db->f("privilege_id");
		$privilege_name = $db->f("privilege_name");
		$privilege_checked = in_array($privilege_id, $admins_recipients) ? " checked " : "";
		$t->set_var("index", $index);
		$t->set_var("privilege_id", $privilege_id);
		$t->set_var("privilege_checked", $privilege_checked);
		$t->set_var("privilege_name", $privilege_name);
		$t->parse("admin_types", true);
	}
	$t->set_var("privileges_total", $index);

	$r->set_form_parameters();

	if(strlen($newsletter_id))	
	{
		$t->set_var("save_button", "Update");
		$t->parse("delete", false);	
	}
	else
	{
		$t->set_var("save_button", "Add Newsletter");
		$t->set_var("delete", "");	
	}

	include("./admin_header.php");
	include("./admin_footer.php");

	$t->pparse("main");

?>