<?php
/*
  ****************************************************************************
  ***                                                                      ***
  ***      ViArt Shop Enterprise 2.7.1                                     ***
  ***      File:  admin_support.php                                        ***
  ***      Built: Wed Sep 20 13:19:51 2006                                 ***
  ***      http://www.viart.com                                            ***
  ***                                                                      ***
  ****************************************************************************
*/


	include("./admin_config.php");
	include($root_folder_path . "includes/common.php");
	include($root_folder_path . "includes/record.php");
	include($root_folder_path . "includes/sorter.php");
	include($root_folder_path . "includes/navigator.php");
	include($root_folder_path . "includes/date_functions.php");
	
	check_admin_security("support");

	$permissions = get_permissions();
	$allow_close = get_setting_value($permissions, "support_ticket_close", 0); 
	$admin_id    = get_session("session_admin_id");

	$admin_support_close_url = new VA_URL("admin_support_reply.php", true);
	$admin_support_close_url->add_parameter("support_id", DB, "support_id");
	$admin_support_close_url->add_parameter("operation", CONSTANT, "close");

	$t = new VA_Template($settings["admin_templates_dir"]);
	$t->set_file("main","admin_support.html");

	$t->set_var("admin_support_href", "admin_support.php");
	$t->set_var("admin_support_reply_href", "admin_support_reply.php");
	$t->set_var("admin_support_request_href", "admin_support_request.php");
	$t->set_var("admin_href", "admin.php");
	$t->set_var("admin_support_priorities_href", "admin_support_priorities.php?rp=admin_support.php");
	$t->set_var("admin_support_statuses_href", "admin_support_statuses.php?rp=admin_support.php");
	$t->set_var("admin_support_products_href", "admin_support_products.php?rp=admin_support.php");
	$t->set_var("admin_support_types_href", "admin_support_types.php?rp=admin_support.php");
	$t->set_var("admin_support_settings_href", "admin_support_settings.php");
	$t->set_var("admin_support_predefined_href", "admin_support_predefined.php");        
	$t->set_var("admin_support_departments_href", "admin_support_departments.php");        
	$t->set_var("admin_support_admins_href", "admin_support_admins.php");     
	$t->set_var("admin_support_static_tables_href", "admin_support_departments.php");        

	
	$s = new VA_Sorter($settings["admin_templates_dir"], "sorter_img.html", "admin_support.php");
	$s->set_parameters(false, true, true, false);
	$s->set_sorter("No", "sorter_id", "1", "s.support_id");
	$s->set_sorter("Summary", "sorter_summary", "2", "s.summary");
	$s->set_sorter("Status", "sorter_status", "3", "ss.status_name");
	$s->set_sorter("Type", "sorter_type", "4", "st.type_name");
	$s->set_sorter("Email", "sorter_user", "5", "s.user_email");
	$s->set_sorter("Assigned", "sorter_admin_alias", "7", "a.admin_alias");
	$s->set_sorter("Last Updated", "sorter_modified", "6", "s.date_modified");
	if (!$s->order_by) {
		$s->order_by = " ORDER BY sp.priority_rank, s.date_modified DESC ";
	}

	$s_am = new VA_Sorter($settings["admin_templates_dir"], "sorter_img.html", "admin_support.php", "sort_am");
	$s_am->set_parameters(false, true, true, false);
	$s_am->set_sorter("No", "sorter_id_am", "1", "s.support_id");
	$s_am->set_sorter("Summary", "sorter_summary_am", "2", "s.summary");
	$s_am->set_sorter("Status", "sorter_status_am", "3", "ss.status_name");
	$s_am->set_sorter("Type", "sorter_type_am", "4", "st.type_name");
	$s_am->set_sorter("Email", "sorter_user_am", "5", "s.user_email");
	$s_am->set_sorter("Last Updated", "sorter_modified_am", "6", "s.date_modified");
	if (!$s_am->order_by) {
		$s_am->order_by = " ORDER BY sp.priority_rank, s.date_modified DESC ";
	}

	$n = new VA_Navigator($settings["admin_templates_dir"], "navigator.html", "admin_support.php");

	include("./admin_header.php");
	include("./admin_footer.php");

	$default_department_id = get_db_value("SELECT dep_id FROM " . $table_prefix . "support_users_departments WHERE is_default_dep = 1 AND admin_id = " . $db->tosql($admin_id, INTEGER));
	$department_id = get_param("department_id");
	if (!$department_id) $department_id = $default_department_id;
	$t->set_var("department_id", $department_id);
	$cur_dep_short_title = "";
	if ($department_id) {
		$cur_dep_short_title = get_db_value("SELECT short_title FROM " . $table_prefix . "support_departments WHERE dep_id = " . $db->tosql($department_id, INTEGER));
	}

	$sql="SELECT status_id, status_name, is_internal FROM " . $table_prefix . "support_statuses ORDER BY status_name ASC";
	$support_statuses = array(array("","--- Select Status ---"));
	$db->query($sql);
	while($db->next_record()) {
		if ($db->f("is_internal") == "1") {
			$support_statuses[] = array($db->f("status_id"), $db->f("status_name") . " (Internal)");
		}
		else {
			$support_statuses[] = array($db->f("status_id"), $db->f("status_name"));
		}
	};
	//-- assigned departments
	$sql = "SELECT * FROM " . $table_prefix . "support_users_departments WHERE admin_id = " . $db->tosql($admin_id, INTEGER);
	$db->query($sql);
	$assigned_deps = array();
	$in_ass_deps = "";
	while ($db->next_record()) {
		$assigned_deps[$db->Record["dep_id"]] = 1;
		if (!strlen($in_ass_deps)) $in_ass_deps .= "(";
		$in_ass_deps .= $db->Record["dep_id"] . ",";
	}
	if (strlen($in_ass_deps)) {
		$in_ass_deps = substr($in_ass_deps, 0, -1) . ")";
	}
	
	$deps_titles = "";
	$deps = array();
	$sql = "SELECT * FROM " . $table_prefix . "support_departments";
	$db->query($sql);
	while ($db->next_record()) {
		$deps[$db->Record["dep_id"]] = array();
		if (isset($assigned_deps[$db->Record["dep_id"]]) && $assigned_deps[$db->Record["dep_id"]])
			$deps_titles .= "<td>&nbsp;<a href='admin_support.php?department_id=" . $db->Record["dep_id"]."'><b>" . $db->Record["short_title"]."</b></a>&nbsp;</td>";
		else $deps_titles .= "<td>&nbsp;<b>" . $db->Record["short_title"]."</b>&nbsp;</td>";
	}

	$sql = "SELECT dep_id, support_status_id, COUNT(*) AS c FROM " . $table_prefix . "support GROUP BY dep_id, support_status_id";
	$db->query($sql);
	$d = 0;
	$stats = array();
	if ($db->next_record()) {
		$last_dep_id = $db->Record["dep_id"];
		do {
			$dep_id = $db->Record["dep_id"];
			if ($last_dep_id != $dep_id) {
				//-- new dep
				$deps[$last_dep_id] = $stats;
				$last_dep_id = $dep_id;
				$stats = array();
			}	
			$stats[$db->Record["support_status_id"]] = $db->Record["c"];
		}
		while ($db->next_record());

		$deps[$last_dep_id] = $stats; 
	}

	$support_statuses_title = "";
	$total_dep = array();
	
	foreach ($support_statuses as $sname) {
		if ($sname[0]) {
			$str = "<td align='left'>" . $sname[1] . "</td>"; 
			$total = 0;
			foreach ($deps as $key => $val) {
				if (isset($deps[$key][$sname[0]]))
					$v = $deps[$key][$sname[0]];
				else
					$v = 0;
				$total += $v;
				if ($v) {
					if (isset($assigned_deps[$key])) {
						if ($assigned_deps[$key]) $str .= "<td class=''><b><a href='admin_support.php?status_id=" . $sname[0] . "&department_id=" . $key . "'>" . $v . "</b></a></td>";
						else $str .= "<td class=''><b>" . $v . "</b></td>";
					}
					else $str .= "<td class=''><b>" . $v . "</b></td>";
				}
				else $str .= "<td>" . $v . "</td>";
				if (isset($total_dep[$key])) $total_dep[$key] += $v;
				else $total_dep[$key] = $v;
			}
			$t->set_var("statuses_count", $str);
			$t->parse("deps", true);
		}
	}	
	
	$t->set_var("statuses_title", $deps_titles);

	$str = "<td align='right' class='middle'><b>Total:</b></td>";
	foreach ($deps as $key => $val)	{
		$str .= "<td class='middle'><b>" . $total_dep[$key] . "</b></td>";
	}

	$t->set_var("statuses_count", $str);
	$t->parse("deps", true);

	$search_options = array(array(0, "Active"), array(1, "Hidden"), array(2, "All"));

	$r = new VA_Record("");
	$r->add_hidden("department_id", TEXT);
	$r->add_textbox("support_id_search", TEXT);
	$r->change_property("support_id_search", TRIM, true);
	$r->add_textbox("summary_search", TEXT);
	$r->change_property("summary_search", TRIM, true);
	$r->add_textbox("s_ne", TEXT);
	$r->change_property("s_ne", TRIM, true);
	$r->add_textbox("keyword_search", TEXT);
	$r->change_property("keyword_search", TRIM, true);
	$r->add_radio("status_id", INTEGER, $support_statuses);
	$r->add_radio("s_in", TEXT, $search_options);

	$r->get_form_parameters();
	if ($r->get_value("s_in") == "") {$r->set_value("s_in", 0);}
	$r->set_value("department_id", $department_id);
	$r->set_form_parameters();

	// create new ticket link
	if (isset($permissions["support_ticket_new"]) && $permissions["support_ticket_new"] == 1) {
		$t->parse("create_ticket_link", false);
	}


	$statuses_is_list = get_db_values("SELECT status_id, is_list FROM " . $table_prefix . "support_statuses", "");
	$in_is_list = "";
	$s_in = $r->get_value("s_in");
	foreach ($statuses_is_list as $value) {
		if ($s_in == 0)
		if ($value[1]) {
			if (!strlen($in_is_list)) $in_is_list .= "(";
			$in_is_list .= $value[0] . ",";
		}
		if ($s_in == 1)
		if (!$value[1]) {
			if (!strlen($in_is_list)) $in_is_list .= "(";
			$in_is_list .= $value[0] . ",";
		}
		if ($s_in == 2)
		{
			if (!strlen($in_is_list)) $in_is_list .= "(";
			$in_is_list .= $value[0] . ",";
		}
	}
	if (strlen($in_is_list)) {
		$in_is_list = substr($in_is_list, 0, -1) . ")";
	}
				
	$where = "";
	$search = "";
	if ($s_in == 1) {$search .= "'<b>Hidden Tickets</b>'";}
	if ($s_in == 2) {$search .= "'<b>All Tickets</b>'";}
	if (!$r->is_empty("status_id")) {
		$where .= " s.support_status_id = " . $db->tosql($r->get_value("status_id"), INTEGER);
		if ($search) $search .= " and ";
		$search .= "Status: '<b>" . get_array_value($r->get_value("status_id"),$support_statuses) . "</b>'";
	}
	elseif (strlen($in_is_list)) {
		$where .= " s.support_status_id IN " . $in_is_list;
	}
	if (!$r->is_empty("summary_search")) {
		if (strlen($where)) $where .= " AND ";
		$where .= " (s.summary LIKE '%" . $db->tosql($r->get_value("summary_search"), TEXT, false) . "%')";
		if ($search) $search .= " and ";
		$search .= "Summary: '<b>" . $r->get_value("summary_search") . "</b>'";
	}
	if (!$r->is_empty("s_ne")) {
		if (strlen($where)) $where .= " AND ";
		$where .= " (s.user_email LIKE '%" . $db->tosql($r->get_value("s_ne"), TEXT, false) . "%'";
		$where .= " OR s.user_name LIKE '%" . $db->tosql($r->get_value("s_ne"), TEXT, false) . "%')";
		if ($search) $search .= " and ";
		$search .= "Name, E-mail: '<b>" . $r->get_value("s_ne") . "</b>'";
	}
	$sql_join_b = "";
	$sql_join_e = "";
	if (!$r->is_empty("keyword_search")) {
		if (strlen($where)) $where .= " AND ";
		$where .= " (s.summary LIKE '%" . $db->tosql($r->get_value("keyword_search"), TEXT, false) . "%'";
		$where .= " OR s.description LIKE '%" . $db->tosql($r->get_value("keyword_search"), TEXT, false) . "%'";
		$where .= " OR sm.message_text LIKE '%" . $db->tosql($r->get_value("keyword_search"), TEXT, false) . "%')";
		$sql_join_b = "(";
		$sql_join_e = "LEFT JOIN " . $table_prefix . "support_messages sm ON sm.support_id = s.support_id) ";
		if ($search) $search .= " and ";
		$search .= "Keyword: '<b>" . $r->get_value("keyword_search") . "</b>'";
	}
	if (!$r->is_empty("support_id_search")) {
		if (strlen($where)) $where .= " AND ";
		$where .= " s.support_id = " . $db->tosql($r->get_value("support_id_search"), INTEGER);
		if ($search) $search .= " and ";
		$search .= "Ticket No: '<b>" . $r->get_value("support_id_search") . "</b>'";
	}
	
	if (!$r->is_empty("department_id")) {
		if (strlen($where)) $where .= " AND ";
		$where .= " s.dep_id = " . $db->tosql($r->get_value("department_id"), INTEGER);
	}
	if (strlen($in_ass_deps)) {
		if (strlen($where)) $where .= " AND ";
		$where .= " s.dep_id IN " . $in_ass_deps;
	}	

	if ($search && ($s_in == 0)) {$search = "'<b>Active Tickets</b>' and " . $search;}
	
	$t->set_var("search", $search);
	if ($search) $t->parse("search_results", false);

	if (strlen($where)) {
		$where_am =  "WHERE s.admin_id_assign_to = " . $db->tosql($admin_id, INTEGER) . " AND " . $where; 
	} else {
		$where_am =  "WHERE s.admin_id_assign_to = " . $db->tosql($admin_id, INTEGER); 
	}

	if (strlen($where)) {
		$where = " WHERE " . $where;
	}

	// set department
	// set up variables for navigator
	$total_records = 0;
	$db->query("SELECT COUNT(*) FROM " . $sql_join_b . $table_prefix . "support s ". $sql_join_e . $where . " GROUP BY s.support_id ");
	while ($db->next_record()) {
		$total_records++;
	}
	$records_per_page = get_param("q") > 0 ? get_param("q") : 25;
	$pages_number = 5;

	// get status_id where is_closed = 1
	$close_status_id = "";
	$sql  = "SELECT status_id FROM " . $table_prefix . "support_statuses WHERE is_closed = 1";
	$db->query($sql);
	if ($db->next_record()) {
		$close_status_id = $db->f("status_id");
	}

// set array html
	$html_status = array();
	$sql="SELECT status_id, status_icon, html_start, html_end FROM " . $table_prefix . "support_statuses";
	$db->query($sql);
	if ($db->num_rows($sql)) {
		while ($db->next_record()) {
			$html_status[$db->f("status_id")] = array($db->f("status_icon"), $db->f("html_start"), $db->f("html_end"));
		}
	}

	$page_number = $n->set_navigator("navigator", "page", SIMPLE, $pages_number, $records_per_page, $total_records, false);
	$db->RecordsPerPage = $records_per_page;
	$db->PageNumber = $page_number;
	
	$short_title = "";
	if (strlen($in_ass_deps)) {
		if ($department_id) {
			if (array_key_exists($department_id, $assigned_deps)) {
				$sql  = " SELECT s.support_id, s.summary, ss.status_name, ss.status_id, st.type_name, s.user_email, a.admin_alias, s.dep_id, ";
				$sql .= " s.date_modified, sd.short_title, a.login, ";
				$sql .= " sp.admin_html, sp.priority_name ";
				$sql .= " FROM " . $sql_join_b . "(((((" . $table_prefix . "support s ";
				$sql .= " LEFT JOIN " . $table_prefix . "support_statuses ss ON ss.status_id = s.support_status_id) ";
				$sql .= " LEFT JOIN " . $table_prefix . "support_types st ON st.type_id = s.support_type_id) ";
				$sql .= " LEFT JOIN " . $table_prefix . "support_priorities sp ON sp.priority_id = s.support_priority_id) ";
				$sql .= " LEFT JOIN " . $table_prefix . "support_departments sd ON sd.dep_id = s.dep_id) ";
				$sql .= " LEFT JOIN " . $table_prefix . "admins a ON a.admin_id = s.admin_id_assign_to) ";
				$sql .= $sql_join_e;
				$sql .= $where;
				$sql .= " GROUP BY s.support_id, s.summary, ss.status_name, ss.status_id, st.type_name, s.user_email, a.admin_alias, s.dep_id, sp.admin_html, sp.priority_name, sp.priority_rank, s.date_modified, sd.short_title, a.login";
				$sql .= $s->order_by;
				$db->query($sql);
				if ($db->next_record()) {
					$admin_support_reply_url = new VA_URL("admin_support_reply.php", true);
					$admin_support_reply_url->add_parameter("support_id", DB, "support_id");
					$admin_support_request_url = new VA_URL("admin_support_request.php", true);
					$admin_support_request_url->add_parameter("support_id", DB, "support_id");
			
					$t->parse("sorters", false);
					$cur_dep = $db->Record["dep_id"];
					$next = false;
					do {
						$t->set_var("support_id", $db->f("support_id"));
			
						$t->set_var("admin_support_reply_url", $admin_support_reply_url->get_url());
						$t->set_var("admin_support_request_url", $admin_support_request_url->get_url());
			
						$t->set_var("summary", htmlspecialchars($db->f("summary")));
						if ($html_status[$db->f("status_id")][1]) {
							$t->set_var("html_start", $html_status[$db->f("status_id")][1]);
							$t->set_var("html_end", $html_status[$db->f("status_id")][2]);
						} else {
							$t->set_var("html_start", "");
							$t->set_var("html_end", "");
						}

						$status = strlen($db->f("status_name")) ? $db->f("status_name") : "New";
						$t->set_var("status", $status);
						if ($html_status[$db->f("status_id")][0]) {
							$t->set_var("status_icon", $html_status[$db->f("status_id")][0]);
							$t->parse("status_ico", false);
						} else {
							$t->set_var("status_ico", "");
						}

						$t->set_var("type", $db->f("type_name"));
						$t->set_var("user_email", $db->f("user_email"));
						if ($db->f("admin_alias") != "") {$t->set_var("admin_alias", $db->f("admin_alias"));
						} else {
						$t->set_var("admin_alias", $db->f("login"));
						}
		
						$priority = "";
						$priority_name = $db->f("priority_name");
						$priority_html = $db->f("admin_html");
						$t->set_var("priority_html", $priority_html);
		
						if ($next) $t->set_var("style","row1");
						else       $t->set_var("style","row2");
						$next = !$next;
		 	
						$date_modified = $db->f("date_modified", DATETIME);
						$date_modified_string = va_date($datetime_show_format, $date_modified);
						$t->set_var("date_modified", $date_modified_string);

						if ($db->f("status_id") != $close_status_id) {
							if ($allow_close) {
								$t->set_var("close_ticket", $admin_support_close_url->get_url());
								$t->set_var("close_summary", "Close ticket");
								$t->parse("close_ticket_enable", false);
							}
							$t->set_var("close_ticket_disable", "");
						} else {
							$t->set_var("close_summary", "Ticket is closed");
							$t->set_var("close_ticket_enable", "");
							$t->parse("close_ticket_disable", false);
						}
						
						if ($cur_dep == $db->Record["dep_id"]) {
							$t->parse("records", true);
						}
						else {
							$t->set_var("dep_name", $short_title);
							$t->parse("department", true);
							$t->parse("records", "");
			
							$cur_dep = $db->Record["dep_id"];
							$t->parse("records", true);
						}
						$short_title = $db->Record["short_title"];
					} while($db->next_record());
					$t->set_var("dep_name", $short_title);
					$t->parse("department", true);
				}
				else {
					$t->set_var("department", "");
					$t->set_var("records", "");
					$t->set_var("navigator_block", "");
					if ($search) {
						$t->set_var("department", "<p><font color='red'><b>No results found for department '". $cur_dep_short_title . "', please refine your search criteria.</b></font>");
					}
				}
			}
			else {
				$t->set_var("department", "<p><font color='red'><b>You are not assigned to this department.</b></font>");
				$t->set_var("records", "");
				$t->set_var("navigator_block", "");
			}
		}
		else {
			$t->set_var("department", "<p><font color='red'><b>You don't have any default department assigned to you or you haven't chosen any department.</b></font>");
			$t->set_var("records", "");
			$t->set_var("navigator_block", "");
		}
	}
	else {
		$t->set_var("department", "<p><font color='red'><b>You are not assigned to any department.</b></font>");
		$t->set_var("records", "");
		$t->set_var("navigator_block", "");
	}

	// set allocated_me
	// set up variables for navigator_am
	$total_records = 0;
	$db->query("SELECT COUNT(*) FROM " . $sql_join_b . $table_prefix . "support s " . $sql_join_e . $where_am . " GROUP BY s.support_id ");
	while ($db->next_record()) {
		$total_records++;
	}
	$records_per_page = get_param("q") > 0 ? get_param("q") : 25;
	$pages_number = 5;

	$page_number = $n->set_navigator("navigator_am", "page_am", SIMPLE, $pages_number, $records_per_page, $total_records, false);
	$db->RecordsPerPage = $records_per_page;
	$db->PageNumber = $page_number;
	
	if (strlen($in_ass_deps)) {
		if ($department_id) {
			if (array_key_exists($department_id, $assigned_deps)) {
				$sql  = " SELECT s.support_id, s.summary, ss.status_name, ss.status_id, st.type_name, s.user_email, s.dep_id, ";
				$sql .= " sp.priority_name, sp.admin_html, s.date_modified, sd.short_title ";
				$sql .= " FROM " . $sql_join_b . "((((" . $table_prefix . "support s ";
				$sql .= " LEFT JOIN " . $table_prefix . "support_statuses ss ON ss.status_id = s.support_status_id) ";
				$sql .= " LEFT JOIN " . $table_prefix . "support_types st ON st.type_id = s.support_type_id) ";
				$sql .= " LEFT JOIN " . $table_prefix . "support_priorities sp ON sp.priority_id = s.support_priority_id) ";
				$sql .= " LEFT JOIN " . $table_prefix . "support_departments sd ON sd.dep_id = s.dep_id) ";
				$sql .= $sql_join_e;
				$sql .= $where_am;
				$sql .= " GROUP BY s.support_id, s.summary, ss.status_name, ss.status_id, st.type_name, s.user_email, s.dep_id, sp.priority_name, sp.admin_html, sp.priority_rank, s.date_modified, sd.short_title ";
				$sql .= $s_am->order_by;
				$db->query($sql);
				if ($db->next_record()) {
					$admin_support_reply_url = new VA_URL("admin_support_reply.php", true);
					$admin_support_reply_url->add_parameter("support_id", DB, "support_id");
			
					$t->parse("sorters_am", false);
					$cur_dep = $db->Record["dep_id"];
					$next = false;
					do {
						$t->set_var("support_id_am", $db->f("support_id"));
			
						$t->set_var("admin_support_reply_url_am", $admin_support_reply_url->get_url());
			
						$t->set_var("summary_am", $db->f("summary"));
						if ($html_status[$db->f("status_id")][1]) {
							$t->set_var("html_start_am", $html_status[$db->f("status_id")][1]);
							$t->set_var("html_end_am", $html_status[$db->f("status_id")][2]);
						} else {
							$t->set_var("html_start_am", "");
							$t->set_var("html_end_am", "");
						}

						$status = strlen($db->f("status_name")) ? $db->f("status_name") : "New";
						$t->set_var("status_am", $status);
						if ($html_status[$db->f("status_id")][0]) {
							$t->set_var("status_icon_am", $html_status[$db->f("status_id")][0]);
							$t->parse("status_ico_am", false);
						} else {
							$t->set_var("status_ico_am", "");
						}

						$t->set_var("type_am", $db->f("type_name"));
						$t->set_var("user_email_am", $db->f("user_email"));
		
						$priority = "";
						$priority_name = $db->f("priority_name");
						$priority_html = $db->f("admin_html");
						$t->set_var("priority_html", $priority_html);
		
						if ($next) $t->set_var("style_am","row1");
						else       $t->set_var("style_am","row2");
						$next = !$next;
		 	
						$date_modified = $db->f("date_modified", DATETIME);
						$date_modified_string = va_date($datetime_show_format, $date_modified);
						$t->set_var("date_modified_am", $date_modified_string);
						
						if ($db->f("status_id") != $close_status_id) {
							if ($allow_close) {
								$t->set_var("close_ticket_am", $admin_support_close_url->get_url());
								$t->set_var("close_summary_am", "Close ticket");
								$t->parse("close_ticket_enable_am", false);
							}
							$t->set_var("close_ticket_disable_am", "");
						} else {
							$t->set_var("close_summary_am", "Ticket is closed");
							$t->set_var("close_ticket_enable_am", "");
							$t->parse("close_ticket_disable_am", false);
						}

						if ($cur_dep == $db->Record["dep_id"]) {
							$t->parse("records_am", true);
						}
						else {
							$t->parse("allocated_me", true);
							$t->parse("records_am", "");
			
							$cur_dep = $db->Record["dep_id"];
							$t->parse("records_am", true);
						}
					} while($db->next_record());
					$t->parse("allocated_me", true);
				}
				else {
					$t->set_var("allocated_me", "");
					$t->set_var("records_am", "");
					$t->set_var("navigator_block_am", "");
				}
			}
			else {
				$t->set_var("records_am", "");
				$t->set_var("navigator_block_am", "");
			}
		}
		else {
			$t->set_var("records_am", "");
			$t->set_var("navigator_block_am", "");
		}
	}
	else {
		$t->set_var("records_am", "");
		$t->set_var("navigator_block_am", "");
	}

	$t->pparse("main");

?>