<?php
/*
  ****************************************************************************
  ***                                                                      ***
  ***      ViArt Shop Enterprise 2.7.1                                     ***
  ***      File:  index.php                                                ***
  ***      Built: Wed Sep 20 13:19:51 2006                                 ***
  ***      http://www.viart.com                                            ***
  ***                                                                      ***
  ****************************************************************************
*/


	include_once ("./includes/common.php");
	include_once ("./includes/navigator.php");
	include_once ("./includes/tree.php");
	include_once ("./includes/date_functions.php");
	include_once ("./messages/".$language_code."/cart_messages.php");
	include_once ("./includes/shopping_cart.php");

	// include blocks
	include_once ("./block_custom.php");
	include_once ("./block_banners.php");

	// articles blocks
	include_once ("./block_articles_categories.php");
	include_once ("./block_articles_latest.php");
	include_once ("./block_articles_top_rated.php");
	include_once ("./block_articles_top_viewed.php");
	include_once ("./block_articles_hot.php");
	include_once ("./block_articles_search.php");

	$layout_id = get_param("layout_id");
	$page_settings = va_page_settings("index", $layout_id);
	$script_name = "index.php";
	$current_page = "index.php";
	$currency = get_currency();
	$currency_left  = $currency["left"];
	$currency_right = $currency["right"];
	$currency_rate  = $currency["rate"];
	$tax_rates = get_tax_rates();

  $t = new VA_Template("./js");
  $t->set_file("compare_js","compare.js");
	$t->set_var("COMPARE_MIN_ALLOWED_MSG", COMPARE_MIN_ALLOWED_MSG);
	$t->set_var("COMPARE_MAX_ALLOWED_MSG", COMPARE_MAX_ALLOWED_MSG);
	$t->parse("compare_js", false);

	$t->templates_path = $settings["templates_dir"];
  $t->set_file("main","index.html");
	$t->set_var("products_href", "products.php");
	$t->set_var("current_href",  "index.php");

	include_once ("./header.php");

	$greeting_html = trim($settings["html_on_index"]);
	if(strlen($greeting_html)) {
		$greeting_html = get_translation($greeting_html);
		$t->set_var("greeting_html", $greeting_html);
		$t->parse("greeting_block", false);
	} else {
		$t->set_var("greeting_block", "");
	}

	$index_title = get_translation(get_setting_value($settings, "index_title", HOME_PAGE_TITLE));
	$meta_description = get_translation(get_setting_value($settings, "index_description"));
	$meta_keywords = get_translation(get_setting_value($settings, "index_keywords"));
	if (!$meta_description) {
		$meta_description = get_meta_desc($greeting_html);
	}


	if(is_array($page_settings)) {
		foreach($page_settings as $setting_name => $setting_value)
		{
			if ($setting_name == "top_products_block") {
				include_once ("./block_products_top_rated.php");
				top_products($setting_value);
			} else if ($setting_name == "products_top_sellers") {
				include_once ("./block_products_top_sellers.php");
				products_top_sellers($setting_value);
			} else if ($setting_name == "search_block") {
				include_once ("./block_search.php");
				search_form($setting_value);
			} else if ($setting_name == "products_recently_viewed") {
				include_once ("./block_products_recently.php");
				products_recently_viewed($setting_value);
			} else if ($setting_name == "products_recommended") {
				include_once ("./block_products_recommended.php");
				products_recommended($setting_value);
			} else if ($setting_name == "categories_block") {
				include_once ("./block_categories_list.php");
				categories($setting_value, "categories");
			} else if ($setting_name == "subcategories_block") {
				include_once ("./block_categories_list.php");
				categories($setting_value, "subcategories");
			} else if ($setting_name == "manufacturers_block") {
				include_once ("./block_manufacturers.php");
				manufacturers($setting_value);
			} else if ($setting_name == "offers_block") {
				include_once ("./block_offers.php");
				offers($setting_value);
			} else if ($setting_name == "products_releases") {
				include_once ("./block_products_releases.php");
				products_releases($setting_value);
			} else if ($setting_name == "ads_search") {
				include_once ("./block_ads_search.php");
				ads_search($setting_value, 0);
			} else if ($setting_name == "ads_hot") {
				include_once ("./block_ads_hot.php");
				ads_hot($setting_value, 0, ADS_TITLE);
			} else if ($setting_name == "ads_categories") {
				include_once ("./block_ads_categories.php");
				ads_categories($setting_value, 0, "ads_categories");
			} else if ($setting_name == "ads_subcategories") {
				include_once ("./block_ads_categories.php");
				ads_categories($setting_value, 0, "ads_subcategories");
			} else if ($setting_name == "ads_recently_viewed") {
				include_once ("./block_ads_recently.php");
				ads_recently_viewed($setting_value);
			} else if ($setting_name == "ads_sellers") {
				include_once ("./block_ads_sellers.php");
				ads_sellers($setting_value, 0);
			} else if ($setting_name == "ads_latest") {
				include_once ("./block_ads_latest.php");
				ads_latest($setting_value);
			} else if ($setting_name == "subscribe_block") {
				include_once ("./block_subscribe.php");
				subscribe_form($setting_value);
			} else if ($setting_name == "sms_test_block") {
				include_once ("./block_sms_test.php");
				sms_test_form($setting_value);
			} else if ($setting_name == "login_block") {
				login_form($setting_value);
			} else if ($setting_name == "cart_block") {
				include_once ("./block_cart.php");
				small_cart($setting_value);
			} else if ($setting_name == "poll_block") {
				include_once ("./block_poll.php");
				poll_form($setting_value);
			} else if ($setting_name == "language_block") {
				include_once ("./block_language.php");
				language_form($setting_value, $page_settings["language_selection"]);
			} else if ($setting_name == "currency_block") {
				include_once ("./block_currency.php");
				currency_form($setting_value);
			} else if (preg_match("/^custom_block_/", $setting_name)) {
				custom_block($setting_value, substr($setting_name, 13));
			} else if (preg_match("/^banners_group_/", $setting_name)) {
				banners_group($setting_value, substr($setting_name, 14));
			} else if (preg_match("/^a_latest_(\d+)$/", $setting_name, $matches)) {
				articles_latest($setting_value, $matches[1], "");
			} else if (preg_match("/^a_top_rated_(\d+)$/", $setting_name, $matches)) {
				articles_top_rated($setting_value, $matches[1], "");
			} else if (preg_match("/^a_top_viewed_(\d+)$/", $setting_name, $matches)) {
				articles_top_viewed($setting_value, $matches[1], "");
			} else if (preg_match("/^a_hot_(\d+)$/", $setting_name, $matches)) {
				articles_hot($setting_value, $matches[1], "", "", "");
			} else if (preg_match("/^a_cats_(\d+)$/", $setting_name, $matches)) {
				articles_categories($setting_value, $matches[1], "", "a_cats");
			} else if (preg_match("/^a_subcats_(\d+)$/", $setting_name, $matches)) {
				articles_categories($setting_value, $matches[1], "", "a_subcats");
			} else if (preg_match("/^a_search_(\d+)$/", $setting_name, $matches)) {
				articles_search($setting_value, $matches[1], "");
			} 

		}
	}

	if(!get_setting_value($page_settings, "left_column_hide", 0)) {
		$t->set_var("left_column_width", get_setting_value($page_settings, "left_column_width", "20%"));
		$t->parse("left_column", false);
	}
	if(!get_setting_value($page_settings, "middle_column_hide", 0)) {
		$t->set_var("middle_column_width", get_setting_value($page_settings, "middle_column_width", "60%"));
		$t->parse("middle_column", false);
	}
	if(!get_setting_value($page_settings, "right_column_hide", 0)) {
		$t->set_var("right_column_width", get_setting_value($page_settings, "right_column_width", "20%"));
		$t->parse("right_column", false);
	}


	include_once ("./footer.php");

	$t->set_var("html_title", $index_title);
	$t->set_var("meta_description", $meta_description);
	$t->set_var("meta_keywords", $meta_keywords);
	$t->pparse("main");
?>