<?php

/*
 * PayPal.com Direct handler by http://www.viart.com/
 */

	// get some variables from our payment settings
	$sandbox        = isset($payment_parameters["sandbox"]) ? $payment_parameters["sandbox"] : 0;
	$sslcert        = isset($payment_parameters["sslcert"]) ? $payment_parameters["sslcert"] : "";


	if ($sandbox == 1) {
		$api_url = "https://api-aa.sandbox.paypal.com/2.0/";
		$paypal_url = "https://www.sandbox.paypal.com/cgi-bin/webscr";
	} else {
		$api_url = "https://api-aa.paypal.com/2.0/";
		$paypal_url = "https://www.paypal.com/cgi-bin/webscr";
	}

	$pass_data = array();
	foreach ($payment_parameters as $parameter_name => $parameter_value) {
		if(isset($pass_parameters[$parameter_name]) && $pass_parameters[$parameter_name] == 1) {
			$pass_data[$parameter_name] = $parameter_value;
		}
	}

	$soap = getDirectSOAP($pass_data);

	$ch = curl_init();
	curl_setopt ($ch, CURLOPT_URL, $api_url);
	curl_setopt ($ch, CURLOPT_POST, 1); 
	curl_setopt ($ch, CURLOPT_POSTFIELDS, $soap); 
	curl_setopt ($ch, CURLOPT_RETURNTRANSFER, 1);
	curl_setopt ($ch, CURLOPT_SSLCERT, $sslcert);
	curl_setopt ($ch, CURLOPT_SSL_VERIFYPEER, 0);
	curl_setopt ($ch, CURLOPT_SSL_VERIFYHOST, 0);
	curl_setopt ($ch, CURLOPT_TIMEOUT, 60); 
	$paypal_response = curl_exec ($ch);
	curl_close ($ch);

	if (strlen($paypal_response)) {
		if (preg_match("/<SOAP-ENV:Fault>/i", $paypal_response)) {
			$faultcode = ""; $faultstring = "";
			if (preg_match("/<faultcode>(.*)<\/faultcode>/i", $paypal_response, $match)) {
				$faultcode = $match[1];
			}
			if (preg_match("/<faultstring>(.*)<\/faultstring>/i", $paypal_response, $match)) {
				$faultstring = $match[1];
			}
			$error_message  = "Some errors occurred during handling your transaction:<br>";
			$error_message .= $faultcode . ": " . $faultstring;
			return;
		} else if (preg_match("/<Errors/i", $paypal_response)) {
			$errorcode = ""; $shortmessage = ""; $longmessage = "";
			if (preg_match("/<ErrorCode[^>]*>(.*)<\/ErrorCode>/i", $paypal_response, $match)) {
				$errorcode = $match[1];
			}
			if (preg_match("/<ShortMessage[^>]*>(.*)<\/ShortMessage>/i", $paypal_response, $match)) {
				$shortmessage = $match[1];
			}
			if (preg_match("/<LongMessage[^>]*>(.*)<\/LongMessage>/i", $paypal_response, $match)) {
				$longmessage = $match[1];
			}
			$error_message  = "Some errors occurred during handling your transaction:<br>";
			$error_message .= $errorcode . ": " . $shortmessage . "<br>";
			if ($sandbox) {
				$error_message .= $longmessage;
			}
			return;
		} else if (preg_match("/<TransactionID[^>]*>(.*)<\/TransactionID>/i", $paypal_response, $match)) {
			$transaction_id = $match[1];

			$ack = ""; $avs_code = ""; $cvv_code = "";
			if (preg_match("/<Ack[^>]*>(.*)<\/Ack>/i", $paypal_response, $match)) {
				$ack = $match[1];
			}
			if (preg_match("/<AVSCode[^>]*>(.*)<\/AVSCode>/i", $paypal_response, $match)) {
				$avs_code = $match[1];
			}
			if (preg_match("/<CVV2Code[^>]*>(.*)<\/CVV2Code>/i", $paypal_response, $match)) {
				$cvv_code = $match[1];
			}
			if (!strlen($ack)) {
				$error_message = "Can't obtain transaction status.";
			} else if (strtolower($ack) != "success") {
				$error_message = "Your transaction status is " . $payment_status;
			} 

		} else {
			$error_message  = "Can't obtain transaction information from PayPal.";
			return;
		}

	} else {
		$error_message  = "Empty response from PayPal, please check your payment settings.";
		return;
	}



	function getDirectSOAP($params) 
	{
		global $token;

		$soap  = '<?xml version="1.0" encoding="UTF-8"?>
<SOAP-ENV:Envelope
   xmlns:xsi="http://www.w3.org/1999/XMLSchema-instance"
   xmlns:SOAP-ENC="http://schemas.xmlsoap.org/soap/encoding/"
   xmlns:SOAP-ENV="http://schemas.xmlsoap.org/soap/envelope/"
   xmlns:xsd="http://www.w3.org/1999/XMLSchema"
   SOAP-ENV:encodingStyle="http://schemas.xmlsoap.org/soap/encoding/">';
		$soap .= '
    <SOAP-ENV:Header>
      <RequesterCredentials
        xmlns="urn:ebay:api:PayPalAPI"
        SOAP-ENV:mustUnderstand="1">
         <Credentials xmlns="urn:ebay:apis:eBLBaseComponents">
';
		if(isset($params["username"]) && strlen($params["username"])) {
			$soap .= "<Username>" . $params["username"] . "</Username>\r\n";
		} else {
			$soap .= "<Username/>\r\n";
		}
		if(isset($params["password"]) && strlen($params["password"])) {
			$soap .= "<Password>" . $params["password"] . "</Password>\r\n";
		} else {
			$soap .= "<Password/>\r\n";
		}
		if(isset($params["Subject"]) && strlen($params["Subject"])) {
			$soap .= "<Subject>" . $params["subject"] . "</Subject>";
		} else {
			$soap .= "<Subject/>";
		}
		$soap .= '
         </Credentials>
      </RequesterCredentials>
		</SOAP-ENV:Header>
		<SOAP-ENV:Body>
		<DoDirectPaymentReq xmlns="urn:ebay:api:PayPalAPI">
			<DoDirectPaymentRequest xmlns="urn:ebay:api:PayPalAPI">
				<Version xmlns="urn:ebay:apis:eBLBaseComponents">1.0</Version>
					<DoDirectPaymentRequestDetails xmlns="urn:ebay:apis:eBLBaseComponents">';
		if(isset($params["paymentaction"]) && strlen($params["paymentaction"])) {
			$soap .= "<PaymentAction>" . $params["paymentaction"] . "</PaymentAction>";
		} else {
			$soap .= "<PaymentAction>Sale</PaymentAction>";
		}

		$currencyID = (isset($params["currencyid"]) && strlen($params["currencyid"])) ? $params["currencyid"] : "USD";

		$soap .= "<PaymentDetails>";
		if(isset($params["ordertotal"]) && strlen($params["ordertotal"])) {
			$soap .= '<OrderTotal currencyID="' . $currencyID . '">' . number_format($params["ordertotal"], 2, ".", "") . '</OrderTotal>';
		} 
		if(isset($params["itemtotal"]) && strlen($params["itemtotal"])) {
			$soap .= '<ItemTotal currencyID="' . $currencyID . '">' . number_format($params["itemtotal"], 2, ".", "") . '</ItemTotal>';
		} 
		if(isset($params["shippingtotal"]) && strlen($params["shippingtotal"])) {
			$soap .= '<ShippingTotal currencyID="' . $currencyID . '">' . number_format($params["shippingtotal"], 2, ".", "") . '</ShippingTotal>';
		} 
		if(isset($params["handlingtotal"]) && strlen($params["handlingtotal"])) {
			$soap .= '<HandlingTotal currencyID="' . $currencyID . '">' . number_format($params["handlingtotal"], 2, ".", "") . '</HandlingTotal>';
		} 
		if(isset($params["taxtotal"]) && strlen($params["taxtotal"])) {
			$soap .= '<TaxTotal currencyID="' . $currencyID . '">' . number_format($params["taxtotal"], 2, ".", "") . '</TaxTotal>';
		} 
		if(isset($params["orderdescription"]) && strlen($params["orderdescription"])) {
			$soap .= "<OrderDescription>" . $params["orderdescription"] . "</OrderDescription>\r\n";
		} 
		if(isset($params["custom"]) && strlen($params["custom"])) {
			$soap .= "<Custom>" . $params["custom"] . "</Custom>\r\n";
		} 
		if(isset($params["invoiceid"]) && strlen($params["invoiceid"])) {
			$soap .= "<InvoiceID>" . $params["invoiceid"] . "</InvoiceID>\r\n";
		} 

		$shipname = (isset($params["shipname"])) ? $params["shipname"] : "";
		$shipstreet1 = (isset($params["shipstreet1"])) ? $params["shipstreet1"] : "";
		$shipstreet2 = (isset($params["shipstreet2"])) ? $params["shipstreet2"] : "";
		$shipcityname = (isset($params["shipcityname"])) ? $params["shipcityname"] : "";
		$shipstateorprovince = (isset($params["shipstateorprovince"])) ? $params["shipstateorprovince"] : "";
		$shipcountry = (isset($params["shipcountry"])) ? $params["shipcountry"] : "";
		$shippostalcode = (isset($params["shippostalcode"])) ? $params["shippostalcode"] : "";
		if (strlen($shipname) || strlen($shipstreet1) || strlen($shipstreet2) || strlen($shipcityname) || strlen($shipstateorprovince) || strlen($shipcountry) || strlen($shippostalcode)) {
			$soap .= "<ShipToAddress>\r\n";
			if (strlen($shipname)) { $soap .= "<Name>" . $shipname . "</Name>\r\n"; }
			if (strlen($shipstreet1)) { $soap .= "<Street1>" . $shipstreet1. "</Street1>\r\n"; }
			if (strlen($shipstreet2)) { $soap .= "<Street2>" . $shipstreet2. "</Street2>\r\n"; }
			if (strlen($shipcityname)) { $soap .= "<CityName>" . $shipcityname. "</CityName>\r\n"; }
			if (strlen($shipstateorprovince)) { $soap .= "<StateOrProvince>" . $shipstateorprovince. "</StateOrProvince>\r\n"; }
			if (strlen($shipcountry)) { $soap .= "<Country>" . $shipcountry . "</Country>\r\n"; }
			if (strlen($shippostalcode)) { $soap .= "<PostalCode>" . $shippostalcode. "</PostalCode>\r\n"; }
			$soap .= "</ShipToAddress>\r\n";
		}

		/* information about ordering items
			$soap .= "<PaymentItem>";
			$soap .= "<Name>" . $item_name . "</Name>";
			$soap .= "<Number>" . $item_id . "</Number>";
			$soap .= "<Quantity>" . $quantity . "</Quantity>";
			$soap .= '<SalesTax currencyID="' . $currencyID . '">' . $sales_tax . "</SalesTax>\r\n";
			$soap .= '<Amount currencyID="' . $currencyID . '">' . $amount . "</Amount>\r\n";
			$soap .= "</PaymentItem>";
		//*/

		$soap .= "</PaymentDetails>";
		$soap .= "<CreditCard>";
		if(isset($params["creditcardtype"]) && strlen($params["creditcardtype"])) {
			$cc_type = $params["creditcardtype"];
			$cc_types = array ("visa" => "Visa", "mc" => "MasterCard", "mastercard" => "MasterCard", "discover" => "Discover", 
			"amex" => "Amex", "american express" => "Amex", "americanexpress" => "Amex");
			if (isset($cc_types[strtolower($cc_type)])) {
				$cc_type = $cc_types[strtolower($cc_type)];
			}
			$soap .= "<CreditCardType>" . $cc_type . "</CreditCardType>\r\n";
		} 
		if(isset($params["creditcardnumber"]) && strlen($params["creditcardnumber"])) {
			$soap .= "<CreditCardNumber>" . $params["creditcardnumber"] . "</CreditCardNumber>\r\n";
		} 
		if(isset($params["expmonth"]) && strlen($params["expmonth"])) {
			$soap .= "<ExpMonth>" . $params["expmonth"] . "</ExpMonth>\r\n";
		} 
		if(isset($params["expyear"]) && strlen($params["expyear"])) {
			$soap .= "<ExpYear>" . $params["expyear"] . "</ExpYear>\r\n";
		} 
		$soap .= "<CardOwner>";
		if(isset($params["payer"]) && strlen($params["payer"])) {
			$soap .= "<Payer>" . $params["payer"] . "</Payer>\r\n";
		} 

		$soap .= "<PayerName>";
		if(isset($params["ccfirstname"]) && strlen($params["ccfirstname"])) {
			$soap .= "<FirstName>" . $params["ccfirstname"] . "</FirstName>\r\n";
		} 
		if(isset($params["cclastname"]) && strlen($params["cclastname"])) {
			$soap .= "<LastName>" . $params["cclastname"] . "</LastName>\r\n";
		} 
		$soap .= "</PayerName>";

		$name = (isset($params["name"])) ? $params["name"] : "";
		$street1 = (isset($params["street1"])) ? $params["street1"] : "";
		$street2 = (isset($params["street2"])) ? $params["street2"] : "";
		$cityname = (isset($params["cityname"])) ? $params["cityname"] : "";
		$stateorprovince = (isset($params["stateorprovince"])) ? $params["stateorprovince"] : "";
		$country = (isset($params["country"])) ? $params["country"] : "";
		$postalcode = (isset($params["postalcode"])) ? $params["postalcode"] : "";
		if (strlen($name) || strlen($street1) || strlen($street2) || strlen($cityname) || strlen($stateorprovince) || strlen($country) || strlen($postalcode)) {
			$soap .= "<Address>\r\n";
			if (strlen($name)) { $soap .= "<Name>" . $name . "</Name>\r\n"; }
			if (strlen($street1)) { $soap .= "<Street1>" . $street1. "</Street1>\r\n"; }
			if (strlen($street2)) { $soap .= "<Street2>" . $street2. "</Street2>\r\n"; }
			if (strlen($cityname)) { $soap .= "<CityName>" . $cityname. "</CityName>\r\n"; }
			if (strlen($stateorprovince)) { $soap .= "<StateOrProvince>" . $stateorprovince. "</StateOrProvince>\r\n"; }
			if (strlen($country)) { $soap .= "<Country>" . $country . "</Country>\r\n"; }
			if (strlen($postalcode)) { $soap .= "<PostalCode>" . $postalcode. "</PostalCode>\r\n"; }
			$soap .= "</Address>\r\n";
		}

		$soap .= "</CardOwner>";
		if(isset($params["cvv2"]) && strlen($params["cvv2"])) {
			$soap .= "<CVV2>" . $params["cvv2"] . "</CVV2>\r\n";
		} 
		$soap .= "</CreditCard>";

		$soap .= "<IPAddress>" . get_var("REMOTE_ADDR") . "</IPAddress>\r\n";
		$soap .= "<MerchantSessionId>" . session_id() . "</MerchantSessionId>\r\n";

		$soap .= "
				</DoDirectPaymentRequestDetails>
			</DoDirectPaymentRequest>
		</DoDirectPaymentReq>
	</SOAP-ENV:Body>
</SOAP-ENV:Envelope>";

		return $soap;
	}

?>